% Example 10.9

X(1:50,1)=unifrnd(0,1,50,1);
X(1:50,2)=unifrnd(0.5,1,50,1);
y(1:50) = 2+sqrt(2)*randn(1,50);
X(51:100,1)=unifrnd(-1,0,50,1);
X(51:100,2)=unifrnd(-0.5,1,50,1);
y(51:100)=3+sqrt(2)*randn(1,50);
X(101:150,1)=unifrnd(-1,0,50,1);
X(101:150,2)=unifrnd(-1,-0.5,50,1);
y(101:150)=10+sqrt(2)*randn(1,50);
X(151:200,1)=unifrnd(0,1,50,1);
X(151:200,2)=unifrnd(-1,0.5,50,1);
y(151:200)=-10+sqrt(2)*randn(1,50);

% Set the maximum number in the nodes.
maxn = 5;				
tree = csgrowr(X,y,maxn);
% Now prune the tree.
treeseq = cspruner(tree);

% Generate an independent test sample.
nprime = 1000;
X(1:250,1)=unifrnd(0,1,250,1);
X(1:250,2)=unifrnd(0.5,1,250,1);
y(1:250) = 2+sqrt(2)*randn(1,250);
X(251:500,1)=unifrnd(-1,0,250,1);
X(251:500,2)=unifrnd(-0.5,1,250,1);
y(251:500)=3+sqrt(2)*randn(1,250);
X(501:750,1)=unifrnd(-1,0,250,1);
X(501:750,2)=unifrnd(-1,-0.5,250,1);
y(501:750)=10+sqrt(2)*randn(1,250);
X(751:1000,1)=unifrnd(0,1,250,1);
X(751:1000,2)=unifrnd(-1,0.5,250,1);
y(751:1000)=-10+sqrt(2)*randn(1,250);
% For each tree in the sequence, 
% find the mean squared error
k = length(treeseq);
msek = zeros(1,k);
numnodes = zeros(1,k);
for i=1:(k-1)
   err = zeros(1,nprime);
   t = treeseq{i};
   for j=1:nprime
      [yhat,node]=cstreer(X(j,:),t);
      err(j) = (y(j)-yhat).^2;
   end
   [term,nt,imp]=getdata(t);
   % find the # of terminal nodes
   numnodes(i) = length(find(term==1));  
   % find the mean   
   msek(i) = mean(err);
end
t = treeseq{k};
msek(k) = mean((y-t.node(1).yhat).^2);
% Find the subtree corresponding to the minimum MSE
[msemin,ind]=min(msek);
minnode = numnodes(ind);
% Find the standard error for that subtree.
t0 = treeseq{ind};
for j=1:nprime
   [yhat,node]=cstreer(X(j,:),t0);
   err(j) = (y(j)-yhat).^4-msemin^2;
end
se = sqrt(sum(err)/nprime)/sqrt(nprime);
