% Example 5.21
load cereal
% This file contains the labels and 
% the matrix of 8 observations.
clf
n=8; p=11;
% Find number of rows and cols for the stars.
ncol=floor(sqrt(n));
nrow=ceil(n/ncol);
% Translate data so there are no negatives. 
% The data will go from
% 1 to 1+range of entire data set.
md = min(cereal(:));
data = 1 + cereal-md;
% Get angles that are linearly spaced.
% Do not use the last point
theta = linspace(0,2*pi,p+1); 
theta(end)=[];
k=0;
for i = 1:n
			k=k+1; 
			% get the observation for plotting
			r=data(k,:); 
			[x,y]=pol2cart(theta,r);
			X=x(:);  % make col vectors
			Y=y(:);
			X = [zeros(p,1) X]; 
			Y = [zeros(p,1) Y];
			x = [x(:); x(1)];
			y = [y(:); y(1)];
			subplot(nrow,ncol,k),
			patch(x,y,'w')
			hold on
			plot(X(1,:),Y(1,:))
			for ii =2:p
   				plot(X(ii,:),Y(ii,:))
			end
			title(labs{k})
			axis off
			hold off
end