% Example 6.11

load forearm
n = length(forearm);
alpha = 0.1;
B = 1000;
thetahat = mom(forearm);
% Estimate the SE using the bootstrap
bvs = bootstrp(50,'mom',forearm);
SE = std(bvs);
% Get the bootstrap replicates and samples.
[bootreps, bootsam] = bootstrp(B,'mom',forearm);
% Set up some storage space for the SEs.
sehats = zeros(size(bootreps));
% Each column of bootsam contains indices 
% to a bootstrap sample.
for i = 1:B
    		% extract the sample from the data 
				xstar = forearm(bootsam(:,i));
   bvals(i) = mom(xstar);
   % Do bootstrap using that sample to estimate SE.
   sehats(i) = std(bootstrp(25,'mom',xstar));
end
zvals = (bootreps - thetahat)./sehats;
% Get the quantiles.
k = B*alpha/2;
szval = sort(zvals);
tlo = szval(k);
thi = szval(B-k);
% Get the endpoints of the interval.
blo = thetahat-thi*SE;
bhi = thetahat-tlo*SE;
