% Example 9.18

load iris
k = 3;
% Put all of the data together.
x = [setosa;versicolor;virginica];
[n,d] = size(x);
% Pick some observations to be the cluster centers.
ind = randperm(n);
ind = ind(1:k);
nc = x(ind,:);
% set up storage
% integer 1,...,k indicating cluster membership
cid = zeros(1,n);	
% Make this different to get the loop started.
oldcid = ones(1,n);
% The number in each cluster.
nr = zeros(1,k);	
% Set up maximum number of iterations.
maxiter = 100;
iter = 1;

while ~isequal(cid,oldcid)	& iter < maxiter
    oldcid = cid;
    % Implement the hmeans algorithm.
    % For each point, find the distance 
    % to all cluster centers.
    for i = 1:n
        dist = sum((repmat(x(i,:),k,1)-nc).^2,2);
        [m,ind] = min(dist);	% assign it to this cluster
        cid(i) = ind;
    end
    % Find the new cluster centers.
    for i = 1:k
        % find all points in this cluster
        ind = find(cid==i);
        % find the centroid
        nc(i,:) = mean(x(ind,:));
        % Find the number in each cluster;
        nr(i) = length(ind);
    end
    iter = iter + 1
end
